# -*- rpm-spec -*-

# Plugin isn't ready for real world use yet - it needs
# a security audit at very least
%define _with_plugin %{?with_plugin:1}%{!?with_plugin:0}

%define with_gtk3 0
%if 0%{?fedora} >= 15
%define with_gtk3 1
%endif

%define with_spice 0
%if 0%{?fedora} >= 16
%define with_spice 1
%endif

%if 0%{?rhel} >= 6
%define with_spice 1
%endif

# spice-gtk is x86 x86_64 only currently:
%ifnarch %{ix86} x86_64
%define with_spice 0
%endif

Name: virt-viewer
Version: 0.4.1
Release: 7%{?dist}%{?extra_release}
Summary: Virtual Machine Viewer
Group: Applications/System
License: GPLv2+
URL: http://virt-manager.org/
Source0: http://virt-manager.org/download/sources/%{name}/%{name}-%{version}.tar.gz
Patch1: %{name}-%{version}-sshport1.patch
Patch2: %{name}-%{version}-sshport2.patch
Patch3: %{name}-%{version}-sshport3.patch
Patch4: %{name}-%{version}-callback-deadlock.patch
Patch5: %{name}-%{version}-zoomlevel.patch
Patch6: %{name}-%{version}-window-title.patch
Patch7: %{name}-%{version}-zoomlevel2.patch
Patch8: %{name}-%{version}-uri-parse-fail.patch
Patch9: %{name}-%{version}-wildcard-hosts.patch
Patch10: %{name}-%{version}-unix-sock-crash.patch
Patch11: %{name}-%{version}-window-title-2.patch
Patch12: %{name}-%{version}-spice-grab.patch
Patch13: %{name}-%{version}-sendkey.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: openssh-clients

%if %{with_gtk3}
BuildRequires: gtk3-devel >= 3.0.0
%else
BuildRequires: gtk2-devel >= 2.12.0
%endif
BuildRequires: libvirt-devel >= 0.6.0
BuildRequires: libxml2-devel
BuildRequires: gtk-vnc-devel >= 0.3.8
%if %{with_spice}
BuildRequires: spice-gtk-devel >= 0.6
%endif
BuildRequires: /usr/bin/pod2man
BuildRequires: intltool
%if %{_with_plugin}
%if 0%{?fedora} > 8
BuildRequires: xulrunner-devel
%else
BuildRequires: firefox-devel
%endif
%endif

%description
Virtual Machine Viewer provides a graphical console client for connecting
to virtual machines. It uses the GTK-VNC or SPICE-GTK widgets to provide
the display, and libvirt for looking up VNC/SPICE server details.

%if %{_with_plugin}
%package plugin
Summary: Mozilla plugin for the gtk-vnc library
Group: Development/Libraries
Requires: %{name} = %{version}

%description plugin
Virtual Machine Viewer provides a graphical console client for connecting
to virtual machines. It uses the GTK-VNC or SPICE-GTK widgets to provide
the display, and libvirt for looking up VNC/SPICE server details.

This package provides a web browser plugin for Mozilla compatible
browsers.
%endif

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1

%build

%if %{_with_plugin}
%define plugin_arg --enable-plugin
%else
%define plugin_arg --disable-plugin
%endif

%if %{with_spice}
%define spice_arg --enable-spice
%else
%define spice_arg --disable-spice
%endif

%if %{with_gtk3}
%define gtk_arg --with-gtk=3.0
%else
%define gtk_arg --with-gtk=2.0
%endif

%configure %{spice_arg} %{plugin_arg} %{gtk_arg}
%__make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
%__make install  DESTDIR=$RPM_BUILD_ROOT
%if %{_with_plugin}
rm -f %{buildroot}%{_libdir}/mozilla/plugins/%{name}-plugin.a
rm -f %{buildroot}%{_libdir}/mozilla/plugins/%{name}-plugin.la
%endif
%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc README COPYING AUTHORS ChangeLog NEWS
%{_bindir}/%{name}
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/ui/
%{_datadir}/%{name}/ui/virt-viewer.xml
%{_datadir}/%{name}/ui/virt-viewer-auth.xml
%{_datadir}/%{name}/ui/virt-viewer-about.xml
%{_mandir}/man1/%{name}*

%if %{_with_plugin}
%files plugin
%defattr(-, root, root)
%{_libdir}/mozilla/plugins/%{name}-plugin.so
%endif

%changelog
* Wed Oct 12 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-7
- Fix initial window title when waiting for guest (rhbz #744374)
- Fix detection of SPICE pointer grabs to update title (rhbz #744377)
- Fix incorrect key sequence for C-A-F9/10/11/12 (rhbz #744370)

* Wed Sep 28 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-6
- Fix crash when using UNIX domain sockets (rhbz #740724)

* Mon Sep 19 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-5
- Fix zoom level on non-primary monitors (rhbz #730901)
- Fix missing domain name in window title (rhbz #739007)
- Don't crash if URI parsing fails (rhbz #734769)
- Fix direct connection to VMs using a wildcard address (rhbz #730911)

* Thu Aug 18 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-4
- Fix initial zoom level setting (rhbz #730901)
- Fix potential deadlock in event callback (rhbz #731132)

* Sun Aug 14 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-3
- More fixes for ssh port tunnelling (rhbz #730346)

* Fri Aug 12 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-2
- Fix ssh port tunnelling (rhbz #730346)

* Thu Aug  4 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.1-1
- Update to 0.4.1 release for SPICE multihead (rhbz #680213)

* Mon Jul 25 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.0-2
- Enable SPICE in RHEL-6 (rhbz #680213)

* Tue Jul 12 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4.0-1
- Update to 0.4.0 release (rhbz #680213, #680331)

* Thu Feb  3 2011 Daniel P. Berrange <berrange@redhat.com> - 0.2.1-3
- Add support for UNIX sockets (rhbz #651604)
- Fix wait for VMs based on UUID (rhbz #631667)

* Tue Jun  8 2010 Daniel P. Berrange <berrange@redhat.com> - 0.2.1-2
- Add translated po files for all available languages (rhbz #510231)

* Fri Jan 15 2010 Daniel P. Berrange <berrange@redhat.com> - 0.2.1-1
- Update to 0.2.1 release with i18n support (rhbz #510231)

* Fri Nov 13 2009 Dennis Gregorovic <dgregor@redhat.com> - 0.2.0-1.1
- Fix conditional for RHEL

* Wed Jul 29 2009 Daniel P. Berrange <berrange@redhat.com> - 0.2.0-1.fc12
- Update to 0.2.0 release

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu May  7 2009 Daniel P. Berrange <berrange@redhat.com> - 0.0.3-5.fc12
- Fix auth against libvirt (rhbz #499594)
- Fix confusion of VNC credentials (rhbz #499595)
- Correct keyboard grab handling (rhbz #499362)

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Jul  7 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.0.3-3.fc10
- fix conditional comparison
- remove file dep

* Wed Jun 25 2008 Daniel P. Berrange <berrange@redhat.com> - 0.0.3-2.fc10
- Rebuild for GNU TLS ABI bump

* Mon Mar 10 2008 Daniel P. Berrange <berrange@redhat.com> - 0.0.3-1.fc9
- Updated to 0.0.3 release

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.0.2-4
- Autorebuild for GCC 4.3

* Fri Jan 11 2008 Daniel P. Berrange <berrange@redhat.com> - 0.0.2-3.fc9
- Set domain name as window title
- Hide input for passwd fields during auth

* Mon Oct 15 2007 Daniel P. Berrange <berrange@redhat.com> - 0.0.2-2.fc8
- Change TLS x509 credential name to sync with libvirt

* Tue Aug 28 2007 Daniel P. Berrange <berrange@redhat.com> - 0.0.2-1.fc8
- Added support for remote console access

* Fri Aug 17 2007 Daniel P. Berrange <berrange@redhat.com> - 0.0.1-2.fc8
- Restrict built to x86 & ia64 because libvirt is only on those arches

* Wed Aug 15 2007 Daniel P. Berrange <berrange@redhat.com> - 0.0.1-1.fc8
- First release

